﻿using ProjectExcavator;
using ProjectExcavator.DrawingObjects;
using ProjectExcavator.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Numerics;
using System.Text;
using System.Threading.Tasks;

namespace ProjectExcavator
{
    public class ParamGenericObject<T, U>
    where T : EntityExcavator
    where U : IDrawingKatki
    {
        private T[] _excavators;
        private U[] _katki;

        private int CountExcavators = 0;
        private int CountKatki = 0;
        private readonly Random random;
        private readonly int Width;
        private readonly int Height;

        public ParamGenericObject(int count, int width, int height)
        {
            _excavators = new T[count];
            _katki = new U[count];
            random = new Random();
            Width = width;
            Height = height;
        }



        public bool Add(T excavator)
        {
            for (int i = 0; i < _excavators.Length; i++)
            {
                if (_excavators[i] == null)
                {
                    _excavators[i] = excavator;
                    CountExcavators++;
                    return true;
                }
            }
            return false;
        }

        public bool Add(U katki)
        {
            for (int i = 0; i < _excavators.Length; i++)
            {
                if (_katki[i] == null)
                {
                    _katki[i] = katki;
                    CountKatki++;
                    return true;
                }
            }
            return false;
        }

        public DrawingExcavator CreateDrawObject()
        {
            Random rand = new Random();
            EntityExcavator excavator = _excavators[rand.Next(0, CountExcavators)];
            IDrawingKatki katki = _katki[rand.Next(0, CountKatki)];
            if (excavator is EntityExcavatorKovsh kovshExcavator)
            {
                return new DrawingExcavatorKovsh(excavator.Speed, excavator.Weight, excavator.BodyColor, kovshExcavator.AdditionalColor, kovshExcavator.Kovsh, kovshExcavator.Katki,
                    Width, Height, katki.GetAmount(), katki.GetShape());
            }

            return new DrawingExcavator(excavator.Speed, excavator.Weight, excavator.BodyColor, Width, Height, katki.GetAmount(), katki.GetShape());
        }
    }
}
