﻿using ProjectExcavator.DrawingObjects;
using ProjectExcavator.Entities;
using ProjectExcavator;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ProjectExcavator
{
    public partial class RandGeneration : Form
    {
        private DrawingExcavator _drawingExcavator;
        private ParamGenericObject<EntityExcavator, IDrawingKatki> objGeneric;
        private readonly int _pictureWidth = 250;
        private readonly int _pictureHeight = 185;
        Random random = new Random();
        public RandGeneration()
        {
            InitializeComponent();
        }
        private void Draw()
        {
            if (_drawingExcavator == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxGen.Width, pictureBoxGen.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawingExcavator.DrawTransport(gr);
            pictureBoxGen.Image = bmp;
        }
        private void buttonGen_Click(object sender, EventArgs e)
        {
            int size = random.Next(1, 10);
            objGeneric = new ParamGenericObject<EntityExcavator, IDrawingKatki>(size, _pictureWidth, _pictureHeight);
            for (int i = 0; i < size; i++)
            {
                EntityExcavator excavator = CreateRandomExcavator();
                IDrawingKatki katki = CreateRandomKatki();
                objGeneric.Add(excavator);
                objGeneric.Add(katki);
                _drawingExcavator = objGeneric.CreateDrawObject();
                _drawingExcavator.SetPosition(random.Next(10, 100), random.Next(10, 100));
                Draw();
            }
        }
        public EntityExcavator CreateRandomExcavator()
        {
            Color color = Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256));
            Color dopColor = Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256));
            EntityExcavator excavator;
            switch (random.Next(0, 2))
            {
                case 1:
                    excavator = new EntityExcavatorKovsh(random.Next(100, 300), random.Next(1000, 3000), color, dopColor, Convert.ToBoolean(random.Next(2)), Convert.ToBoolean(random.Next(2)));
                    break;
                default:
                    excavator = new EntityExcavator(random.Next(100, 300), random.Next(1000, 3000), color);
                    break;
            }
            return excavator;
        }
        public IDrawingKatki CreateRandomKatki()
        {
            IDrawingKatki _katki;
            switch (random.Next(3))
            {
                case 1:
                    _katki = new DrawKatkiTriangle();
                    break;
                case 2:
                    _katki = new DrawKatkiSquare();
                    break;
                default:
                    _katki = new DrawKatkiCircle();
                    break;
            }
            _katki.Properties = (random.Next(1, 4));
            return _katki;
        }
    }
}
